using Amazon.Lambda.Core;
using Microsoft.Extensions.DependencyInjection;

// Assembly attribute to enable the Lambda function's JSON input to be converted into a .NET class.
[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]

namespace LambdaDIEmptyFunction;

public class Function
{
    readonly ServiceProvider _serviceProvider;
    public Function()
    {
        Console.WriteLine("Setting up the DI container");
        var serviceCollection = new ServiceCollection();
        Console.WriteLine("Adding a scoped service");
        serviceCollection.AddScoped<ISomeService, SomeService>();
        _serviceProvider = serviceCollection.BuildServiceProvider();
    }

    public string FunctionHandler(string input, ILambdaContext context)
    {
        string upperCaseText;
        using (var scope = _serviceProvider.CreateScope())
        {
            var someService = scope.ServiceProvider.GetRequiredService<ISomeService>();
            upperCaseText = someService.ToUpperCase(input);
        }

        return upperCaseText;
    }
}