using Amazon.Lambda.Core;
using Amazon.Lambda.RuntimeSupport;
using Amazon.Lambda.Serialization.SystemTextJson;
using Microsoft.Extensions.DependencyInjection;

Console.WriteLine("Setting up the DI container");
var serviceCollection = new ServiceCollection();
Console.WriteLine("Adding a singleton service");
serviceCollection.AddSingleton<ISomeService, SomeService>();
ServiceProvider serviceProvider = serviceCollection.BuildServiceProvider();

var handler = (string input, ILambdaContext context) =>
{   
    var someService = serviceProvider.GetService<ISomeService>();
    string upperCaseText = someService.ToUpperCase(input);

    return upperCaseText;
};

await LambdaBootstrapBuilder.Create(handler, new DefaultLambdaJsonSerializer())
        .Build()
        .RunAsync();